<template>
  <div>
    <AppWindow
        v-bind:show="show"
        title="Edit circle"
        cancelable
        @canceled="() => this.$emit('canceled')"
        width="700"
        @submitted="saveBtnClick"
        :disabled-submit="!validForm"
    >
      <br>
      <v-form v-model="validForm">
        <v-row>
          <v-col>
            <v-text-field
                label="Center X"
                v-model="circle.info.center_x"
                color="secondary"
                suffix="m"
                hint="eg: 5e-9"
                :rules="[isNumber, notEmpty]"
            ></v-text-field>
          </v-col>
          <v-col>
            <v-text-field
                label="Center Y"
                v-model="circle.info.center_y"
                color="secondary"
                suffix="m"
                hint="eg: 5e-9"
                :rules="[isNumber, notEmpty]"
            ></v-text-field>
          </v-col>
          <v-col>
            <v-text-field
                label="Radius"
                v-model="circle.info.radius"
                color="secondary"
                suffix="m"
                hint="eg: 5e-9"
                :rules="[isNumber, notEmpty]"
            ></v-text-field>
          </v-col>
        </v-row>
      </v-form>

      <template v-slot:submit-text>
        Save
      </template>
    </AppWindow>
  </div>
</template>

<script>
import AppWindow from './../AppWindow/AppWindow'
import {AppContext} from '@Util'

export default {
  name: 'EditCircle',
  components: {
    AppWindow
  },
  props: {
    show: Boolean,
    circle: Object
  },
  data: () => ({
    isNumber: val => !isNaN(Number(val)) || `${val} is not a valid number`,
    notNul: val => val !== '0' || 'Must be different from 0',
    notEmpty: val => val !== '' || `Can't be empty`,
    validForm: false,
  }),
  watch: {
    show(val) {
      Object.assign(AppContext, {mode: val ? 0 : 2})
    }
  },
  methods: {
    saveBtnClick() {
      AppContext.currentProject.resetSim()
      this.$emit('saved')
    }
  }
}
</script>